/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.functionsample.sample000;

import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.JobContext;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.batch.openapi.SupportLogic;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.batch.functionsample.common.CustomerData;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * サポートクラス。<br>
 * 顧客テーブルのデータをクリアし、新規データを作成する。<br>
 */
public class Sample000PreLogic05 implements SupportLogic<JobContext> {

    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(Sample000PreLogic05.class);

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO;
    
    /**
     * 処理を起動する。
     */
    public BLogicResult execute(JobContext jobContext) {

    if(log.isDebugEnabled()){
        log.debug("start.");
    }
    
    updateDAO.execute("SAMPLE000.deleteCustomer", null);
        
    CustomerData cust = new CustomerData();
    for(String custName:Sample000PreLogic04.aryCustname){
        cust.setCustname(custName);
        updateDAO.execute("SAMPLE000.insertCustomer", cust);
    }
    
    if(log.isDebugEnabled()){
        log.debug("end.");
    }
    
    return new BLogicResult(ReturnCode.NORMAL_CONTINUE);
    }

    /**
     * UpdateDAOを設定する。
     * @param updateDAO 設定するUpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }
    

}
